//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaContoursSetViewerPosition.h"
#include "bbcreaContoursPackage.h"
namespace bbcreaContours
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaContours,SetViewerPosition)
BBTK_BLACK_BOX_IMPLEMENTATION(SetViewerPosition,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void SetViewerPosition::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  

	if (bbGetInputPosition().size()==3 )
	{
		int x = bbGetInputPosition()[0];
		int y = bbGetInputPosition()[1];
		int z = bbGetInputPosition()[2];
		if ((backX!=x) || (backY!=y) || (backZ!=z) )   // this prevent to finish contour before start  :-)
		{
			if (bbGetInputwxContourMainFrame()!=NULL)
			{
				double 			slice;
				vtkImageData 	*img 		= bbGetInputwxContourMainFrame()->getImageData();
				int 			ext[6];
				img->GetExtent(ext);
				int dimY=ext[3]-ext[2]+1;
				if (bbGetInputDirection()==0)
				{
					slice = z;
					slice = round( slice/bbGetInputJump() ) * bbGetInputJump() + bbGetInputShift();
					bbGetInputwxContourMainFrame()->setConceptValue( "Axe Depth", slice );
					bbGetInputwxContourMainFrame()->SetXY(x,y);
				} // if Direction1

				if (bbGetInputDirection()==1)
				{
					slice = y;
					slice = round( slice/bbGetInputJump() ) * bbGetInputJump() + bbGetInputShift();
					bbGetInputwxContourMainFrame()->setConceptValue( "Axe Depth", slice );
					bbGetInputwxContourMainFrame()->SetXY(x,dimY-z-1);
				} // if Direction1

				if (bbGetInputDirection()==2)
				{
					slice = x;
					slice = round( slice/bbGetInputJump() ) * bbGetInputJump() + bbGetInputShift();
					bbGetInputwxContourMainFrame()->setConceptValue( "Axe Depth", slice );
					bbGetInputwxContourMainFrame()->SetXY(dimY-z-1,y);
				} // if Direction1
				bbGetInputwxContourMainFrame()->showAxis(true);
				bbGetInputwxContourMainFrame()->changeInstant();
				bbGetInputwxContourMainFrame()->RefreshInterface();
				backX=x;
				backY=y;
				backZ=z;
			} // if bbGetInputPosition
		} // if bbGetInputwxContourMainFrame
	} // if backX  backY  backZ

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void SetViewerPosition::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
	bbSetInputDirection(0);
	bbSetInputJump(1);
  	bbSetInputShift(0);
	bbSetInputwxContourMainFrame(NULL);

	backX=-9999;
	backY=-9999;
	backZ=-9999;
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void SetViewerPosition::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void SetViewerPosition::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaContours


